local ETS = select(2, ...)
local _G = _G
local pairs = pairs

local function tsfUpdate()
	if CURRENT_TRADESKILL ~= "" then
		UIDropDownMenu_Initialize(EasyTradeSkillDropDown, EasyTradeSkillDropDown_Init)
	end
end

local function AdjustTradeSkillFrame()
	local tsf = TradeSkillFrame
	if not tsf.adjusted then
		local tsfh = tsf:GetHeight()
		local ETSFilterButton = CreateFrame("Button", "EasyTradeSkillFilterButton", tsf, "UIMenuButtonStretchTemplate")
		local ETSDropDown = CreateFrame("Frame", "EasyTradeSkillDropDown", ETSFilterButton, "UIDropDownMenuTemplate")
		local hasmats = CreateFrame("CheckButton", "EasyTradeSkillHasMaterials", tsf, "OptionsCheckButtonTemplate")
		local hasmatstext = hasmats:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall")
		local skillup = CreateFrame("CheckButton", "EasyTradeSkillSkillUp", tsf, "OptionsCheckButtonTemplate")
		local skilluptext = skillup:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall")
		if tsfh < 500 then tsf:SetHeight(tsfh + 35)end

		TradeSkillFrameSearchBox:SetPoint("TOPLEFT", TradeSkillRankFrame, "BOTTOMLEFT", 8, -34)
		TradeSkillExpandButtonFrame:SetPoint("TOPLEFT", tsf, "TOPLEFT", 2, -83)
		TradeSkillHorizontalBarLeft:SetPoint("TOPLEFT", tsf, "TOPLEFT", 2, -233)
		TradeSkillListScrollFrame:SetPoint("TOPLEFT", tsf, "TOPLEFT", -34, -108)
		TradeSkillFrameInset:SetPoint("TOPLEFT", tsf, "TOPLEFT", 4, -106)
		TradeSkillFilterButton:Hide()

		ETSFilterButton:SetText(_G.FILTER)
		ETSFilterButton:SetWidth(70)
		ETSFilterButton:SetHeight(22)
		ETSFilterButton:SetPoint("LEFT", TradeSkillFilterFrame, "LEFT")
		ETSFilterButton:SetScript("OnClick", function() ToggleDropDownMenu(1, nil, EasyTradeSkillDropDown, "EasyTradeSkillFilterButton", 74, 15) end)
		EasyTradeSkillFilterButtonRightArrow:Show()

		UIDropDownMenu_Initialize(EasyTradeSkillDropDown, EasyTradeSkillDropDown_Init, "MENU");
		EasyTradeSkillDropDownText:SetJustifyH("CENTER");
		EasyTradeSkillDropDownButton:Show();
		hooksecurefunc("TradeSkillFrame_Update", tsfUpdate)

		hasmats:SetScript("OnClick",
			function() 
				tsf.filterTbl.hasMaterials  = not tsf.filterTbl.hasMaterials
				TradeSkillOnlyShowMakeable(tsf.filterTbl.hasMaterials)
				TradeSkillUpdateFilterBar()
			end)
		hasmats:SetChecked(tsf.filterTbl.hasMaterials)
		hasmats:SetPoint("TOPLEFT", TradeSkillRankFrame, "BOTTOMLEFT", -5, -4)
		hasmatstext:SetText("|cffffffff" .. _G.CRAFT_IS_MAKEABLE)
		hasmatstext:SetPoint("LEFT", hasmats, "RIGHT", 5, 0)

		skillup:SetScript("OnClick",
			function()
				tsf.filterTbl.hasSkillUp  = not tsf.filterTbl.hasSkillUp
				TradeSkillOnlyShowSkillUps(tsf.filterTbl.hasSkillUp)
				TradeSkillUpdateFilterBar()
			end )
		skillup:SetChecked(tsf.filterTbl.hasSkillUp)
		skillup:SetPoint("LEFT", hasmats, "LEFT", 130, 0)
		skilluptext:SetText("|cffffffff" .. _G.TRADESKILL_FILTER_HAS_SKILL_UP)
		skilluptext:SetPoint("LEFT", skillup, "RIGHT", 5, 0)

		TradeSkillFilterBarExitButton:SetScript("OnClick", 
			function()
				TradeSkillFrame.filterTbl = {hasMaterials = false, hasSkillUp = false, subClassValue = -1, slotValue = -1 }
				TradeSkillOnlyShowSkillUps(TradeSkillFrame.filterTbl.hasSkillUp)
				TradeSkillOnlyShowMakeable(TradeSkillFrame.filterTbl.hasMaterials)
				SetTradeSkillCategoryFilter(TradeSkillFrame.filterTbl.subClassValue, 0)
				SetTradeSkillInvSlotFilter(TradeSkillFrame.filterTbl.slotValue, 1, 1)
				TradeSkillUpdateFilterBar()
				hasmats:SetChecked(nil)
				skillup:SetChecked(nil)
				CloseDropDownMenus()
			end)
		tsf.adjusted = true
	end
	if IsTradeSkillGuild() then	EasyTradeSkillSkillUp:Hide()
	else EasyTradeSkillSkillUp:Show() end
end

local function eventHandler(self, event, ...) if event == "TRADE_SKILL_SHOW" then AdjustTradeSkillFrame() end end
ETS.frame = CreateFrame("Frame")
ETS.frame:RegisterEvent("TRADE_SKILL_SHOW")
ETS.frame:SetScript("OnEvent", function(...) eventHandler(...) end)

function EasyTradeSkillDropDown_Init(self, level)
	local info = UIDropDownMenu_CreateInfo()
	if level == 1 then
		info.checked = 	nil
		info.isNotRadio = nil
		info.text = TRADESKILL_FILTER_SLOTS
		info.func =  nil
		info.notCheckable = true
		info.keepShownOnClick = false
		info.hasArrow = true
		info.value = 1
		UIDropDownMenu_AddButton(info, level)
		info.text = TRADESKILL_FILTER_SUBCLASS
		info.func =  nil
		info.notCheckable = true
		info.keepShownOnClick = false
		info.hasArrow = true
		info.value = 2
		UIDropDownMenu_AddButton(info, level)
	elseif level == 2 then
		if UIDROPDOWNMENU_MENU_VALUE == 1 then
			local slots = {GetTradeSkillSubClassFilteredSlots(0)}
			local subslots = {}
			for i,slot in pairs(slots) do
				info.text = slot
				info.func =  function() TradeSkillSetFilter(0, i, "", slots[i]) end
				info.notCheckable = true
				info.hasArrow = false
				UIDropDownMenu_AddButton(info, level)
			end
		elseif UIDROPDOWNMENU_MENU_VALUE == 2 then
			local subClasses = {GetTradeSkillSubClasses()}
			local subslots = {}
			for i,subClass in pairs(subClasses) do
				info.text = subClass
				info.func =  function() TradeSkillSetFilter(i, 0, subClasses[i], "") end
				info.notCheckable = true
				subslots  = {GetTradeSkillSubClassFilteredSlots(i)}
				info.hasArrow = #subslots > 1
				info.value = i
				UIDropDownMenu_AddButton(info, level)
			end
		end
	elseif level == 3 then
		local subClasses = {GetTradeSkillSubClasses()}
		local subslots  = {GetTradeSkillSubClassFilteredSlots(UIDROPDOWNMENU_MENU_VALUE)}
		for i,slot in pairs(subslots) do
			info.text = slot
			info.func =  function() TradeSkillSetFilter(UIDROPDOWNMENU_MENU_VALUE, i, subClasses[UIDROPDOWNMENU_MENU_VALUE], subslots[i]) end
			info.notCheckable = true
			info.value = {UIDROPDOWNMENU_MENU_VALUE, i}
			UIDropDownMenu_AddButton(info, level)
		end
	end
end